/**
 * inversify v.2.0.0-alpha.7 - A lightweight IoC container written in TypeScript.
 * Copyright (c) 2015 Remo H. Jansen
 * MIT inversify.io/LICENSE
 * http://inversify.io
 */
import * as METADATA_KEY from "../constants/metadata_keys";
import * as ERRORS_MSGS from "../constants/error_msgs";
function paramNames() {
    var names = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        names[_i - 0] = arguments[_i];
    }
    return function (target) {
        if (Reflect.hasOwnMetadata(METADATA_KEY.PARAM_NAMES, target) === true) {
            throw new Error(ERRORS_MSGS.DUPLICATED_PARAM_NAMES_DECORATOR);
        }
        Reflect.defineMetadata(METADATA_KEY.PARAM_NAMES, names, target);
        return target;
    };
}
export default paramNames;
